/*
**++
**  FACILITY:
**
**      GLOBAL.H
**
**  ABSTRACT:
**
**       TBS
**
**  AUTHORS:
**
**      C. K. Hung
**	Planning Research Corporation
**	1150 Gemini Avenue
**	Houston, TX 77058
**	Phone: (713)282-6227
**
**
**  CREATION DATE:     7-12-89
**
**  MODIFICATION HISTORY:
**	19Mar90(CKH): Add enum type rings.
**	05Apr91(CKH): Changes for upgrading to DX II
**--
**/

/*
**
**  INCLUDE FILES
**
**/
#ifdef __AXP
/* No define __int64 in SYS$STARLET_C.TLB but use in  XABDATDEF.H 	*/
/* Builtins contain __int64 						*/
#define	__int64	struct{int : 32, :32;}
/* _INSQTI and _REMQHI are not defined otherwise . 			*/
/* It can be found in builtins but it screw the __int64 . Happy DECing 	*/
/* #include builtins - Include a part of builtins			*/

static const int __INSQTI_MAP_ALPHA_TO_VAX[] = {1,0,2};
static const int __REMQHI_MAP_ALPHA_TO_VAX[] = {1,3,0,2};

int __PAL_INSQTIL(void *head, void *new_entry);       /* At tail, interlocked */
int __PAL_REMQHIL(void *head, void **removed_entry);  /* At head,interlocked  */

#define _INSQTI(new_entry, head)                        \
        __INSQTI_MAP_ALPHA_TO_VAX[__PAL_INSQTIL((head), (new_entry))+1]
#define _REMQHI(head, removed_entry)                    \
        __REMQHI_MAP_ALPHA_TO_VAX[__PAL_REMQHIL((head), (removed_entry))+1]
#endif

#include ctype
#include descrip
#include rms
#include smgdef
#include ssdef
#include stdio
#include stdlib
#include string
#include unixio

/*
**  MACRO DEFINITIONS
**/

	/**  Directory where DX.EXE  **/
	/**  and DXHELP.HLB located  **/
#define HELPLIB			"DX$HOME:"
#define DX$HELPLIB		"SYS$HELP:DXHELP"


/*
#define DEFAULT_STARTUP		"DX$STARTUP.DAT"
*/						/**  Default settings file   **/
#define DEFAULT_STARTUP		"SYS$LOGIN:DX$STARTUP.DAT"


#define MAXFILESPEC		255		/**  Max file spec (all cap) **/

#define MAXVMSNODE		63		/**  Max NODE in chars       **/
#define MAXVMSDEVICE		63		/**  Max DEVICE in chars     **/
#define MAXVMSDIRECTORY		39		/**  Max DIRECTORY in chars  **/
#define MAXVMSFILENAME		39		/**  Max FILENAME in chars   **/
#define MAXVMSFILETYPE		39		/**  Max FILETYPE in chars   **/
#define MAXVMSFILEVERSION	5		/**  Max VERSION in chars    **/

#define MAXVMSFULLNAME		(MAXVMSFILENAME+MAXVMSFILETYPE+MAXVMSFILEVERSION)

#define EOS			'\0'		/**  End of string symbol    **/

#define DX__DONTCARE		0		/**  Don't care - do nothing **/
#define DX__NORMAL		1		/**  Success return status   **/
#define DX__ERROR		-1		/**  Generic error	     **/

#define MAXFILEITEMS		4096		/**  Max. files in a direct  **/

#define min(n1, n2)		((int)n1 < (int)n2? n1 : n2)
#define max(n1, n2)		((int)n1 > (int)n2? n1 : n2)

static unsigned long int ss_status;		/**  RTL condition value    **/
#define check_OK(func)				/**  RTL function checker   **/\
    {									       \
	ss_status = func;						       \
	if ( !(ss_status & 1) )						       \
	{								       \
	    fprintf(stderr, "\033[2J");		/**  ANSI erase screen	    **/\
	    fprintf (stderr,						       \
		"\n_DX-F-SVC, RTL or system service error at line %d in",      \
			     __LINE__);					       \
	    fprintf (stderr,						       \
		"\n              file %s", __FILE__);			       \
	    lib$stop(ss_status);		/**  Abort!		    **/\
	}								       \
    }

/**  Literal descriptor  **/
static	struct	dsc$descriptor_s _temp_descr_1 = 
    {	
	0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0
    };
#define LENGTH(descriptor)	descriptor.dsc$w_length
#define POINTER(descriptor)	descriptor.dsc$a_pointer
#define $DESCR(literal)							       \
    (LENGTH (_temp_descr_1) = sizeof literal - 1, POINTER (_temp_descr_1) = literal, &_temp_descr_1)

/*
**
**  GLOBAL DECLARATIONS
**
**/

struct display_tag		    /**  SMG$ virtual display structure	     **/
    {
	unsigned long int id;			/**  Display id		     **/
	int rows, width;			/**  Size of the display and **/
	int beg_y, beg_x;			/**  Upper-left position     **/
	int view_rows, view_width;		/**  Size of the viewprt and **/
	int view_beg_y, view_beg_x;		/**  Upper-left position     **/
    };

typedef struct { unsigned : 32; unsigned: 32; } DATE_TIME;

enum forms					/**  Display format	     **/
    {
	short_form, long_form
    };

enum sortbys					/**  Sort by                 **/
    { 
	sortname, sorttype, sortsize, sortmark,
	sortcredate, sortrevdate, sortexpdate, sortbakdate 
    }; 

enum sortorders					/**  Sort order              **/
    { 
	ascending, descending 
    }; 

enum filemodes					/**  File mode (single/multi)**/
    {
	single, multiple
    }; 

enum directions					/**  Forward or backward     **/
    {
	 advance, backup 
    }; 

struct w_dids_tag		    /**  Data struct used by directory	     **/
    {
	char equivalent_name[MAXFILESPEC+1];	/**  Equivalent name	     **/
	unsigned short int did[3];		/**  File id		     **/
	unsigned short int chan;		/**  I/O channel	     **/
	struct w_dids_tag *next;		/**  Next item in list       **/
    };

struct filespec_list_tag	    /**  Data struct used by filespec list   **/
    {
	char name[MAXFILESPEC+1];		/**  Name (may be a logical) **/
	struct w_dids_tag *w_dids;		/**  Directories in the name **/
	struct filespec_list_tag *next;		/**  Next item in list	     **/
    };

struct cur_filter_tag		    /**  All about file filters		     **/
    {
	struct filespec_list_tag 
		    *name_filespec_list,	/**  Filter name	     **/
		    *exclude_filespec_list;     /**  Filter exclude	     **/
	short int date;				/**  Date (CREATION,MODIFIED **/
						/**    EXPIRED, or BACKUP)   **/
	DATE_TIME before,			/**  Filter before	     **/
		  since;			/**  Filter after	     **/
	unsigned int maximum,			/**  Filter less than	     **/
		     minimum;			/**  Filter larger than	     **/
    };

struct fil_dx_tag		    /**  Information about a file	     **/
    {
	unsigned short int fid[3],		/**  VMS file-ID	     **/
			   did[3];		/**  Directory ID	     **/
	char fn[MAXFILESPEC+1];			/**  File spec		     **/
	long int filesize;			/**  File size		     **/
	DATE_TIME cdat,				/**  Creation date	     **/
		  rdat,				/**  Revision date	     **/
		  edat,				/**  Expire date	     **/
		  bdat;				/**  Backup date	     **/
	unsigned short int fpro;		/**  File protection	     **/
	enum					/**  File state		     **/
	    { 
		waiting, ready, executed
	    } state;				/**  File status	     **/
	long int beg_y, beg_x;			/**  File display pos	     **/
	struct fil_dx_tag *forward,		/**  Forward and	     **/
			  *backward;		/**  Backward links	     **/
};

struct dir_dx_tag		    /**  Information about a directory	     **/
    {
	struct display_tag dir_info_display,	/**  Status display 	     **/
			   filer_display;	/**  Directory display 	     **/
	enum forms form;			/**  Display format	     **/
	enum sortbys sortby;                    /**  Sort by                 **/
	enum sortorders	sortorder;              /**  Sort order              **/
	enum filemodes filemode;                /**  File mode (single/multi)**/
	enum directions	direction;		/**  Forward or backward     **/
	char cur_dir[MAXFILESPEC+1];		/**  Directory name	     **/
	char par_dir[MAXFILESPEC+1];		/**  Parent directory name   **/
	char search_pattern[MAXFILESPEC+1];	/**  Search pattern	     **/
	long int tot_files,			/**  Total files	     **/
		 tot_blocks;			/**  Total blocks	     **/
	long int sel_files,			/**  Files selected	     **/
		 sel_blocks;			/**  Blocks selected	     **/
	unsigned short int dpro;		/**  Directory protection    **/
	short int subdir;			/**  # of subdir	     **/
	struct cur_filter_tag cur_filter;       /**  Filter		     **/
	struct fil_dx_tag *dir_filelist,	/**  Directory files	     **/
			  *non_dir_filelist,    /**  Non-directory files     **/
			  *exclude_filelist,    /**  Exclude files	     **/
			  *cur_file;		/**  Current file pointer    **/
    };

struct user_pref_tag		    /**  Data struct used by user preference **/
    {
	unsigned use_short_form: 1;		/**  Display short form?     **/
	short int editor;			/**  Current editor used     **/
#define		  DX_EDITOR_EDT		1	/**    Use EDT		     **/
#define		  DX_EDITOR_TPU		2	/**    Use TPU		     **/
#define		  DX_EDITOR_LSE		3	/**    Use LSE		     **/
	short int display_date;			/**  Date for display	     **/
#define		  DX_CREDATE		1	/**    Use creation date     **/
#define		  DX_REVDATE		2	/**    Use revision date     **/
#define		  DX_EXPDATE		3	/**    Use expiration date   **/
#define		  DX_BAKDATE		4	/**    Use backup date	     **/
	unsigned type_by_page: 1;		/**  Pause at page?	     **/
	unsigned delete_confirm: 1;		/**  Confirm before del?     **/
	unsigned purge_confirm: 1;		/**  Confirm before purg?    **/
	unsigned auto_update: 1;		/**  Update direct auto?     **/
	unsigned display_clock: 1;		/**  Display clock?	     **/
	unsigned update_in_second: 1;           /**  Update clock in second  **/
    }; 

struct cntrl_info_block_tag	    /**  Default setting and user pref	     **/
    {
	unsigned long int pasteboard_id;	/**  Pasteboard id	     **/
	long int pasteboard_rows,		/**  Pasteboard rows	     **/
	         pasteboard_width;		/**  Pasteboard width	     **/
	unsigned long int keyboard_id;		/**  Keyboard id	     **/
	struct display_tag commands_display,	/**  Commands display 	     **/
			   status_display;	/**  Status display 	     **/
	unsigned short windows;			/**  Number of windows	     **/
	unsigned short cur_win;			/**  Current window	     **/
#define MAXWINDOWS		10		/**  Max number of directory **/
	struct dir_dx_tag dir_dx[MAXWINDOWS];	/**  Directory structure     **/
	char original_cwd[MAXFILESPEC+1];	/**  Dir before entering DX  **/
	struct user_pref_tag user_pref;		/**  User preference settings**/
    } cntrl_info_block;

#define DX_CURRENT_DIRECTORY	cntrl_info_block.dir_dx[cntrl_info_block.cur_win]
#define DX_CURRENT_FILE		DX_CURRENT_DIRECTORY.cur_file
