/*
**++
**  FACILITY:
**
**      MENUNAVI.H
**
**  ABSTRACT:
**
**      Declarations for menu navigator
**
**  AUTHORS:
**
**      C. K. Hung
**
**
**  CREATION DATE:      12-JUL-1990
**
**  MODIFICATION HISTORY:
**
**--
*/


/*
**  MACRO DEFINITIONS
**/

#define MAXCOMMANDSITEMNUM	20		/**  Max. no. of options     **/
#define MAXCOMMANDSITEMLENGTH	40		/**  Max. length of options  **/
#define MENU_SEPARATOR		"-----"		/**  Menu separator	     **/


/*
**  GLOBAL DECLARATIONS
**/

struct menutype		    /**  Menu structure				     **/
    {
	char *itmstr;				/**  Menu item		     **/
	long int start_row, start_col;		/**  Start row and column    **/
	char *item[MAXCOMMANDSITEMNUM];		/**  Sub-menu items	     **/
	int (*op[MAXCOMMANDSITEMNUM])();	/**  Sub-menu functions	     **/
    };


/*
**  FUNCTION PROTOTYPING
**/

    unsigned short int	navigator(struct menutype *, int *, int);
    unsigned short	get_menu_choice(struct menutype, int *);
    int			create_submenu(struct display_tag, char **);
    int			select_from_submenu(struct display_tag, 
			    struct menutype, int *, char *, unsigned short *);
    int			highlight_general_cmd(struct menutype, unsigned long *);
    int			unhighlight_general_cmd(struct menutype, unsigned long *);
